<?php

/**
 * titulo_tasa actions.
 *
 * @package    canon
 * @subpackage titulo_tasa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class titulo_tasaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_TITULO_TASA',
        'CA_TASA_INTERES',
        'MESES',
        'RMN_TITULO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(//si posee tablas para joins, identificar la relacion de los campos con las tablas
        'CA_TASA_INTERES, LEFT' =>
        array(
            'id_tasa_interes' => 'CA_TITULO_TASA'
        ),
        'MESES, LEFT' =>
        array(
            'id_meses' => 'CA_TASA_INTERES'
        ),
        'RMN_TITULO' =>
        array(
            'id_titulo' => 'CA_TITULO_TASA'
        )
    );
    protected $fields = array(
        'CA_TITULO_TASA' =>
        array(
            'id_titulo_tasa' => 'id_titulo_tasa',
            'id_titulo' => 'id_titulo',
            'id_tasa_interes' => 'id_tasa_interes',
            'fecha_mod' => 'fecha_mod',
            'id_usuario' => 'id_usuario',
            'aplica_usura' => 'aplica_usura',
            'estado' => 'estado'
        ),
        'CA_TASA_INTERES' =>
        array(
            'valor' => 'valor'
        ),
        'MESES' =>
        array(
            'descripcion' => 'mes'
        ),
        'RMN_TITULO' =>
        array(
            'cod_titulo' => 'cod_titulo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_TITULO_TASA' => array(
            'id_titulo_tasa,a' => array('!=' => array(-1)),
            'id_titulo_tasa,b' => array('=' => array('id_titulo_tasa')),
            'estado' => array('=' => array('estado')),
            'aplica_usura' => array('=' => array('aplica_usura')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_titulo_tasa'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_titulo_tasa'; //identificador de la tabla
    protected $id_names = array('id_titulo_tasa'); //llave primaria
    protected $field_names = array('id_titulo', 'id_tasa_interes', 'fecha_mod', 'id_usuario', 'aplica_usura', 'estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_TITULO_TASA'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_tasa_interes'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = true;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['id_usuario'] = $request['id_usuario_log'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - ");


        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $idTituloTasa = $list_data_post[0]['id_titulo_tasa'];
                $idTitulo = $list_data_post[0]['id_titulo'];

                //Actualizar los otros registros de titulo tasa
                $sql = <<<EOD
UPDATE CA_TITULO_TASA
SET estado           =0
WHERE ID_TITULO_TASA != $idTituloTasa
AND ID_TITULO        = $idTitulo                    
                        
                        
EOD;

                //ejecuta y obtiene el resultado del sql
                CN_TABLE::executeSQL($sql);


                $this->conn->commit();
                $this->status = 0;
                $this->list_data = array();
            } catch (Exception $e) {
                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $this->status = 1;
                $this->mensajeError = "[titulo_tasa] Ocurrio un error: " . $e->getMessage();
                $this->list_data = array();
                $this->logMessage("[titulo_tasa] ERROR!");
                $this->logMessage($e->getMessage());
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */

            $whereAprobadoRev = ' ';
            if (isset($request['id_estado_rev'])) {
                $whereAprobadoRev = " AND tab0.id_estado_rev = '" . $request['id_estado_rev'] . "' ";
            }

            $whereSinGestion = ' ';
            if (isset($request['sin_gestion']) && $request['sin_gestion'] == "true") {
                $whereSinGestion = " AND tab0.id_estado_rev is null";
            }

            $whereTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $whereTitulo = " AND tab0.id_titulo = '" . $request['id_titulo'] . "' ";
            }

            $whereCompetencia = ' ';
            if (isset($request['id_competencia'])) {
                $whereCompetencia = " AND tab0.id_competencia = '" . $request['id_competencia'] . "' ";
            }

            $id_meses = $request['id_meses'];
            $id_anhos = $request['id_anhos'];

            $orderBy = 'ORDER BY tab3.cod_titulo';
            if (isset($request['_sortBy'])) {
                $orderBy = "ORDER BY " . $request['_sortBy'];
            }

            /**
             * Validar que hay tasa de usuara para el mes y año actual - 20170104
             */
            $sql = <<<EOD
select * from CA_TASA_INTERES 
where 
vigencia=to_char(sysdate, 'yyyy') 
and id_meses=to_char(sysdate, 'mm') 
EOD;

            $total_tasa = CN_TABLE::executeSQL($sql);

            if (count($total_tasa) == 0) {
                $anho_completo = date('Y'); //anho completo cuatro digitos
                $mes = date('m'); //mes con dos digitos
                $error = "[TTULO_TASA] INF: Debe registrar Tasa de Usuara para el año($anho_completo) y mes($mes).";
                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $error;
                $this->logMessage($error);
            } else {


                $query = "
SELECT   tab0.id_titulo_tasa as id_titulo_tasa, tab0.id_titulo as id_titulo, tab0.id_tasa_interes as id_tasa_interes, 
to_char(tab0.fecha_mod, 'YYYY-MM-DD') as fecha_mod, tab0.id_usuario as id_usuario, tab0.aplica_usura as aplica_usura, 
tab0.estado as estado, tab1.vigencia, tab2.descripcion as mes, tab3.cod_titulo as cod_titulo,
-- tasa de interes
case
  when tab0.aplica_usura=0 then tab1.valor
  else tiact.valor
end as valor,
c.nombre as desc_competencia
FROM CA_TITULO_TASA tab0  
LEFT JOIN CA_TASA_INTERES tab1 ON tab0.id_tasa_interes = tab1.id_tasa_interes  
LEFT JOIN MESES tab2 ON tab1.id_meses = tab2.id_meses  
JOIN RMN_TITULO tab3 ON tab0.id_titulo = tab3.id_titulo 
JOIN CA_TASA_INTERES tiact on tiact.vigencia=to_char(sysdate, 'yyyy') and tiact.id_meses=to_char(sysdate, 'mm')
JOIN IN_TITULO_COMPETENCIA tc on tab0.id_titulo = tc.id_titulo
JOIN RMN_COMPETENCIA c on tc.id_competencia=c.id_competencia
WHERE  tab0.id_titulo_tasa != '-1' and tc.actual=1 $whereTitulo
$orderBy

";

                /*
                 * sql que trae los resultados
                 * por los filtros, para totalizar las filas
                 */
                $sql = <<<EOD
select count(*) as count from(
 
$query      
 
)tabla
EOD;

                $total_record_count = CN_TABLE::executeSQL($sql);
                $total_record_count = $total_record_count[0]["count"];

                //validar si hay registros
                if ($total_record_count > 0) {

                    /*
                     * Obtiene los accesos para un perfil
                     */
                    $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
$query     
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                    //ejecuta y obtiene el resultado del sql
                    $records = CN_TABLE::executeSQL($sql);

                    // Solo registra log la primera vez de consulta
                    if ($rowStart == 0) {
                        //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                        $id_ope_bd = 1;
                        //obtener id maestro tabla
                        $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_novedad_rev_tit');
                        //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                        //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                    }

                    $this->totalRows = $total_record_count;
                    $this->startRow = $rowStart;
                    $this->endRow = $rowEnd;
                    $this->status = 0;
                    $this->list_data = $records;
                    $this->logMessage("[TTULO_TASA] Consulta exitosa.");
                } else {

                    $mensaje = "[TTULO_TASA] No hay registros de consulta.";
                    $this->status = 0;
                    $this->list_data = array();
                    $this->logMessage($mensaje);
                }
            }
        } catch (Exception $e) {
            $error = "[TTULO_TASA] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

}
